<?php
/*
//http://www.php.net/manual/fr/function.curl-setopt.php#71313
function curl_redir_exec($ch, &$redirects, $curlopt_header = false)
{
  static $curl_loops = 0;
  static $curl_max_loops = 20;
  if ($curl_loops++ >= $curl_max_loops)
    {
      $curl_loops = 0;
      return FALSE;
    }
  curl_setopt($ch, CURLOPT_HEADER, true);
  curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
  $data = curl_exec($ch);
  list($header, $data) = explode("\n\n", $data, 2);
  $http_code = curl_getinfo($ch, CURLINFO_HTTP_CODE);
  if ($http_code == 301 || $http_code == 302)
    {
      $matches = array();
      preg_match('/Location:(.*?)\n/', $header, $matches);
      $url = @parse_url(trim(array_pop($matches)));
      if (!$url)
	{
	  //couldn't process the url to redirect to
	  $curl_loops = 0;
	  return $data;
	}
      $last_url = parse_url(curl_getinfo($ch, CURLINFO_EFFECTIVE_URL));
      if (!$url['scheme'])
	$url['scheme'] = $last_url['scheme'];
      if (!$url['host'])
	$url['host'] = $last_url['host'];
      if (!$url['path'])
	$url['path'] = $last_url['path'];
      $new_url = $url['scheme'] . '://' . $url['host'] . $url['path'] . ($url['query']?'?'.$url['query']:'');
      curl_setopt($ch, CURLOPT_URL, $new_url);
      //echo ('<p>Redirecting to '. $new_url.'</p>');
      //return curl_redir_exec($ch);
      return $new_url;
    } else {
    $curl_loops=0;
    return $data;
  }
}*/

/* Some error offset in the previous fonction, here another one, surely corrected by the author of the previous function
http://edmoi.blogspot.com/2011/07/curloptfollowlocation-cannot-be.html
*/
function curl_redir_exec($ch, &$redirects, $curlopt_header = false) {

  curl_setopt($ch, CURLOPT_HEADER, true);
  curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
  $data = curl_exec($ch);//var_dump($data);
  $http_code = curl_getinfo($ch, CURLINFO_HTTP_CODE);
  if ($http_code == 301 || $http_code == 302) {
    if (DEBUG == 1){
      echo '<h1>$data=</h1><p>'.$data."</p>";
    }
    list($header) = explode("\n\n", $data, 2);
    if (DEBUG == 1){
      echo '<h1>$header=</h1><p>'.$header."</p>";
    }
    $matches = array();
    preg_match('/(Location:|URI:)(.*?)\n/', $header, $matches);
    $url = trim(array_pop($matches));
    $url_parsed = parse_url($url);
    if (DEBUG == 1){
      echo '<h1>$url=</h1><p>'.$url."</p>";
    }
    if (isset($url_parsed)) {
      return $url;
      curl_setopt($ch, CURLOPT_URL, $url);
      $redirects++;
      return curl_redir_exec($ch, $redirects);
    }
  }
  if ($curlopt_header)
    return $data;
  else {
    if (DEBUG == 1){
      echo '<h1>dans le else $data=</h1><p>'.$data."</p>";
    }
    list(,$body) = explode("\n\n", $data, 2);// ICI 1
    if (DEBUG == 1){
      echo '<h1>dans le else $body=</h1><p>'.$body."</p>";
    }
    return $body;
  }
}

// uploade une image locale sur un hébergeur distant (pour l'instant uniquement de type toile-libre)
function upload($filename,$hebergeur,$tags,$description,$mimetype){
  //echo "<p>".$hebergeur."</p>";
  require_once("config.php");
  $HEBERGEURS = unserialize(HEBERGEURS);
  $tags = html_entity_decode($tags, ENT_QUOTES, 'UTF-8');
  $description = html_entity_decode($description, ENT_QUOTES, 'UTF-8');

  if (array_key_exists($hebergeur, $HEBERGEURS['toile-libre'])){
    $host = $HEBERGEURS['toile-libre'][$hebergeur];
    upload_toile_libre($filename,$host,$tags,$description,$mimetype);
  }else{
    die("Hébergeur de destination non supporté");
  }

}

// envoie une image sur un hébergeur type toile-libre (liste donnée dans config.php, non exhaustive)
function upload_toile_libre($filename,$host,$tags,$description,$mimetype){
  if (DEBUG == 1){
    if (file_exists($filename)) echo "<h1>Le fichier $filename existe :D</h1>";
    else echo "<h1>Le fichier $filename n'existe pas :(</h1>";
  }


  $hebergeur = $host.'/?action=upload';

  $curl_connection =
    curl_init($hebergeur);

  curl_setopt($curl_connection, CURLOPT_CONNECTTIMEOUT, 30);
  curl_setopt($curl_connection, CURLOPT_RETURNTRANSFER, true);
  curl_setopt($curl_connection, CURLOPT_SSL_VERIFYPEER, false);
  curl_setopt($curl_connection, CURLOPT_POST, true);
  curl_setopt($curl_connection, CURLOPT_VERBOSE, true);

  // chemin absolu
  $info = new SplFileInfo($filename);  
  $absolutefilename=$info->getRealPath();
  if (DEBUG == 1){
    if (is_readable($absolutefilename)) echo "<h1>Le fichier $absolutefilename est lisible :D</h1>";
    else echo "<h1>Le fichier $absolutefilename n'est pas lisible :(</h1>";
  }
  $donnees = array(
		   'MAX_FILE_SIZE'=>'15360000',
		   'img'=>"@$absolutefilename;type=$mimetype",
		   'tags'=>$tags,
		   'description'=>$description
		   );
  if (DEBUG == 1){
    var_dump($donnees);
  }
  curl_setopt($curl_connection, CURLOPT_POSTFIELDS, $donnees); 
  $compteur=1;
  
  $postResult =curl_redir_exec($curl_connection, $compteur);
  if (DEBUG == 1){
    echo "<h1>Debug curl</h1>";
    debug_curl($curl_connection,$postResult);
  }
  $urlpix = $postResult;
  
  $parties = explode("=",$urlpix);
  $imagename = $parties[1]; // ICI 2

  $mini = $host.'/upload/thumb/'.$imagename;
  $orig = $host.'/upload/original/'.$imagename;
  $redim =  $host.'/upload/img/'.$imagename;

  $miniforum = "[url=".$urlpix.'][img]'.$mini.'[/img][/url]';
  $minilinkorigforum = "[url=".$orig.'][img]'.$mini.'[/img][/url]';
  $redimforum = "[url=".$urlpix.'][img]'.$redim.'[/img][/url]';
  include("codes.php");
}

// débugue une requête curl avec différentes infos et des commandes chiantes à retenir → fonction
function debug_curl($curl_connection,$postResult){

  echo "</p><p>==> curl_getinfo(curl connection) :</p><p>";

  print_r(curl_getinfo($curl_connection));
  echo "</p><p>==> curl_errno(curl connection) :</p><p>";
  echo curl_errno($curl_connection);
  echo "</p><p>==> curl_error(curl connection) :</p><p>";

  echo curl_error($curl_connection);

  curl_close($curl_connection);
  echo "</p><p>==> résultat de la requête :</p><p>";

  var_dump( "$postResult</p>"); 

}


/**
 * Creates recursively a nested HTML UL of array keys.
 * @param array $array Array
 * @return string Nested UL string
 */
// Crée le formulaire où on choisit l'hébergeur, toile-libre par défaut
function listHebergeursForm($array=array()) {
  $resultat = "";

  if (empty($array)) return '';

  if (is_array($array)){
    foreach ($array as $key => $elem){
      if (is_array($elem)){
	foreach ($elem as $key => $value){
	  $resultat .= '<input type="radio" name="hebergeur" value="'.$key.'" id="'.$key.'" />';

	  $resultat .= '<label class="inline" for="'.$key.'">'.$value.'</label>';
	}
      }else{
	$resultat .= '<input type="radio" name="hebergeur" value="'.$key.'" id="'.$key.'" />';

	$resultat .= '<label class="inline" for="'.$key.'">'.$elem.'</label>';

      }
    }
  }

  return $resultat;
}

/**
 * I had for quite some time been using getimagesize() to check for the
 * existence of a remote image. This turned out to take way too long.
 * The following curl solution only checks the http headers so it is much more
 * efficient.
 * http://www.php.net/manual/en/function.getimagesize.php#92451
 */
// teste l'existence d'un fichier distant
function checkRemoteFile($url)
{
    $ch = curl_init();
    curl_setopt($ch, CURLOPT_URL,$url);
    // don't download content
    //curl_setopt($ch, CURLOPT_NOBODY, 1);
    //curl_setopt($ch, CURLOPT_FAILONERROR, 1);
    curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1);
    //$postResult =curl_exec($ch);
    //debug_curl($ch,$postResult);

    if ((curl_exec($ch))!==FALSE)
    {
        return true;
    }
    else
    {
        return false;
    }



}
?>